<template>
  <div id="feeds-tab-content">
    <!-- If categories -->
    <div v-if="categories.length > 0">
      <p class="refresh-button" @click="refreshStoreData">
        <v-icon name="sync-alt"></v-icon>
        <span>{{ $t(`global.refresh`) | capitalize }}</span>
      </p>
      <div class="feeds-tab-filters-container">
        <p>
          <span class="text-muted">{{ $t(`${GLOBALS.__T_PREFIX__}.global.category`) | capitalize }}:</span>
          <span
            :class="'feeds-tab-category-filter p-1 ml-1 ' + (filters.category.length > 0 ? '' : 'current-filter')"
            @click="switchCategoryFilter(null)"
          >{{ $t(`${GLOBALS.__T_PREFIX__}.global.all`) | capitalize }}</span>
          <span
            v-for="category in categories"
            :key="category.id"
            :class="'feeds-tab-category-filter p-1 ml-1 ' + (filters.category.indexOf(category.id) === -1 ? '' : 'current-filter')"
            @click="switchCategoryFilter(category.id)"
          >{{ category.label }}</span>
        </p>
      </div>
      <b-container v-for="category in filteredCategories" :key="category.id">
        <div class="category-title">
          <p class="h2 pb-2">
            <v-icon name="bookmark" :color="category.color"></v-icon>
            {{ category.label }}
          </p>
          <div class="action-buttons">
            <v-icon name="plus" class="add-source-button" @click="addSourceToCategory(category)"></v-icon>
            <v-icon name="link" class="list-sources-button" @click="listCategorySources(category)"></v-icon>
            <v-icon name="cog" class="edit-button" @click="editCategory(category)"></v-icon>
          </div>
        </div>
        <div v-if="!feedsDataLoading">
          <b-row v-if="lastArticlesByCategory(category.id).length > 0">
            <b-col cols="4" v-for="(article, index) in lastArticlesByCategory(category.id)" :key="index">
              <article-card
                :article="article"
              ></article-card>
            </b-col>
          </b-row>
          <p v-else>{{ $t(`${GLOBALS.__T_PREFIX__}.global.noFeedsMessage`) }}</p>
        </div>
        <div v-else>
          <p>{{ $t(`global.loading`) | capitalize }}</p>
        </div>
      </b-container>
      <edit-category-modal
        :v-model="showEditCategoryModal"
        :category="categoryToEdit"
        @ok="showEditCategoryModal = false"
        @cancel="showEditCategoryModal = false"
      />
      <list-category-sources-modal
        :v-model="showListCategorySourcesModal"
        :category="categoryToEdit"
        @ok="showListCategorySourcesModal = false"
      />
      <add-source-modal
        :v-model="showAddSourceModal"
        :category="categoryToEdit"
        @ok="showAddSourceModal = false"
        @cancel="showAddSourceModal = false"
      />
    </div>
    <!-- Else, new category button -->
    <div v-else>
      <i18n :path="`${GLOBALS.__T_PREFIX__}.global.noCategoryMessage`" tag="p">
        <!-- ref: {0} -->
        <br/>
      </i18n>
      <p>
        <ms-button
          text-align="left"
          @click.native="showCreateCategoryModal = !showCreateCategoryModal"
        >
          <v-icon name="plus" scale="0.6"></v-icon>
          {{ $t(`${GLOBALS.__T_PREFIX__}.global.newCategory`) | capitalize }}
        </ms-button>
      </p>
      <create-category-modal
        :v-model="showCreateCategoryModal"
        @ok="showCreateCategoryModal = false"
        @cancel="showCreateCategoryModal = false"
      />
    </div>
  </div>
</template>

<script>
import { BaseComponent } from '@/utils/'

import EditCategoryModal from '@/components/elements/modals/EditCategoryModal'
import AddSourceModal from '@/components/elements/modals/AddSourceModal'
import CreateCategoryModal from '@/components/elements/modals/CreateCategoryModal'
import ListCategorySourcesModal from '@/components/elements/modals/ListCategorySourcesModal'
import ArticleCard from '@/components/elements/ArticleCard'

export default {
  extends: BaseComponent,
  components: {
    ArticleCard,
    AddSourceModal,
    EditCategoryModal,
    CreateCategoryModal,
    ListCategorySourcesModal
  },
  data () {
    return {
      showEditCategoryModal: false,
      showCreateCategoryModal: false,
      showAddSourceModal: false,
      showListCategorySourcesModal: false,
      categoryToEdit: null,
      filters: {
        category: [] // empty array by default -> show all
      }
    }
  },
  computed: {
    filteredCategories: function () {
      if (this.filters.category.length > 0) {
        return this.categories.filter((cat) => {
          return this.filters.category.indexOf(cat.id) !== -1
        })
      } else {
        return this.categories
      }
    }
  },
  methods: {
    refreshStoreData: function () {
      this.initFeeds()
    },
    switchCategoryFilter: function (categoryId) {
      // If null, clear filters
      if (!categoryId) {
        this.filters.category = []
      } else {
        // If already set, unset
        const found = this.filters.category.indexOf(categoryId)
        if (found !== -1) {
          this.filters.category.splice(found, 1)
        } else {
          this.filters.category.push(categoryId)
        }
      }
    },
    editCategory: function (category) {
      this.categoryToEdit = category
      this.showEditCategoryModal = true
    },
    addSourceToCategory: function (category) {
      this.categoryToEdit = category
      this.showAddSourceModal = true
    },
    listCategorySources: function (category) {
      this.categoryToEdit = category
      this.showListCategorySourcesModal = true
    }
  },
  state: {
    MyFeedsModule: [
      'feeds',
      'categories'
    ]
  },
  getters: {
    MyFeedsModule: [
      'findByCategory',
      'lastArticlesByCategory',
      'feedsDataLoading'
    ]
  },
  actions: {
    MyFeedsModule: [
      'initFeeds'
    ]
  }
}
</script>
